package com.gic.plug.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.plug.web.vo.CityVO;
import com.gic.plug.web.vo.ProvinceVO;
import com.gic.store.dto.CityDTO;
import com.gic.store.dto.CountyDTO;
import com.gic.store.dto.ProvinceDTO;
import com.gic.store.service.ProvincesApiService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.ArrayList;
import java.util.List;

@Controller
public class ProvincesController {
    @Autowired
    private ProvincesApiService provincesApiService;

    @RequestMapping("dict-district-list")
    @ResponseBody
    public Object provinces(String id, @RequestParam(defaultValue = "1")int type){
        switch (type){
            case 1:
                ServiceResponse<List<ProvinceDTO>> serviceResponse = this.provincesApiService.selectAllProvince();
                return RestResponse.success(EntityUtil.changeEntityListByJSON(ProvinceVO.class, serviceResponse.getResult()));
            case 2:
                ServiceResponse<List<CityDTO>> serviceResponse1 = this.provincesApiService.selectAllCity();
                if(serviceResponse1.isSuccess()){
                    List<CityDTO> list = serviceResponse1.getResult();
                    List<CityVO> resultList = new ArrayList<>();
                    for(CityDTO cityDTO : list){
                        if(cityDTO.getProvinceId().equals(id)){
                            resultList.add(EntityUtil.changeEntityByJSON(CityVO.class, cityDTO));
                        }
                    }
                    return RestResponse.success(resultList);
                }
            case 3:
                ServiceResponse<List<CountyDTO>> serviceResponse2 = this.provincesApiService.selectAllCounty();
                if(serviceResponse2.isSuccess()){
                    List<CountyDTO> list = serviceResponse2.getResult();
                    List<CountyDTO> resultList = new ArrayList<>();
                    for(CountyDTO countyDTO : list){
                        if(countyDTO.getCityId().equals(id)){
                            resultList.add(EntityUtil.changeEntityByJSON(CountyDTO.class, countyDTO));
                        }
                    }
                    return RestResponse.success(resultList);
                }
        }
        return RestResponse.success();
    }
}
